"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const bannedHeaders = [
    "Accept",
    "Accept-Charset",
    "Accept-Encoding",
    "Accept-Language",
    "Content-Encoding",
    "Content-Length",
    "Content-Type",
    "ETag",
    "Expect",
    "Expires",
    "If-Match",
    "If-None-Match",
    "If-Modified-Since",
    "If-Unmodified-Since",
    "If-Range",
    "Last-Modified",
    "Transfer-Encoding",
    "Vary",
].map(s => s.toLowerCase());
function getHeaderValue(headers, key) {
    return headers[key.toLowerCase()];
}
exports.getHeaderValue = getHeaderValue;
function writeHttpHeaders(headers, writeHeader) {
    const headerPairs = Object.entries(headers).filter(([key]) => !bannedHeaders.includes(key.toLowerCase()));
    for (const [header, value] of headerPairs) {
        writeHeader(header, value);
    }
}
exports.writeHttpHeaders = writeHttpHeaders;
//# sourceMappingURL=httpHeaders.js.map