"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const parser_combinators_1 = require("@reactive-js/parser-combinators");
const httpGrammar_1 = require("./httpGrammar");
exports.pMediaType = charStream => {
    const type = httpGrammar_1.pToken(charStream);
    parser_combinators_1.pForwardSlash(charStream);
    const subtype = httpGrammar_1.pToken(charStream);
    const params = httpGrammar_1.pParams(charStream);
    return {
        type,
        subtype,
        params,
    };
};
exports.parseMediaType = parser_combinators_1.parseWith(exports.pMediaType);
exports.parseMediaTypeOrThrow = parser_combinators_1.parseWithOrThrow(exports.pMediaType);
exports.mediaTypeToString = ({ type, subtype, params, }) => {
    const stringParams = Object.entries(params)
        .map(([k, v]) => `${k}=${httpGrammar_1.toTokenOrQuotedString(v)}`)
        .join("; ");
    return `${type}/${subtype}${stringParams.length > 0 ? ";" + stringParams : ""}`;
};
//# sourceMappingURL=mediaType.js.map