import { Operator } from "@reactive-js/pipe";
import { HttpStatusCode, HttpHeaders, URILike, HttpPreferences, HttpResponse, HttpRequest, EntityTag } from "./interfaces";
export declare const createHttpResponse: <T>(statusCode: HttpStatusCode, options?: {
    content?: T | undefined;
    etag?: EntityTag | undefined;
    expires?: number | undefined;
    headers?: import("@reactive-js/option").Option<HttpHeaders>;
    lastModified?: number | undefined;
    location?: URILike | undefined;
    preferences?: HttpPreferences | undefined;
    vary?: import("@reactive-js/option").Option<readonly string[]>;
}) => HttpResponse<T>;
export declare const parseHttpResponseFromHeaders: <T>(statusCode: number, headers: HttpHeaders, body: T) => HttpResponse<import("./interfaces").HttpContent<T>>;
export declare const writeHttpResponseHeaders: <T>(response: HttpResponse<import("./interfaces").HttpContent<T>>, writeHeader: (header: string, value: string) => void) => void;
export declare const checkIfNotModified: <T>({ headers: reqHeaders, method, }: HttpRequest<unknown>) => Operator<HttpResponse<T>, HttpResponse<T>>;
