import { Operator } from "@reactive-js/pipe";
import { HttpMethod, URILike, HttpHeaders, HttpPreferences, HttpRequest, HttpResponse, HttpServerRequest, HttpRequestPreconditions } from "./interfaces";
export declare const createHttpRequest: <T>(method: HttpMethod, uri: string | URILike, options?: {
    content?: T | undefined;
    expectContinue?: boolean | undefined;
    headers?: import("@reactive-js/option").Option<HttpHeaders>;
    preconditions?: HttpRequestPreconditions | undefined;
    preferences?: HttpPreferences | undefined;
    httpVersionMajor?: number | undefined;
    httpVersionMinor?: number | undefined;
}) => HttpRequest<T>;
export declare const createRedirectHttpRequest: <TReq, TResp>(response: HttpResponse<TResp>) => Operator<HttpRequest<TReq>, HttpRequest<TReq>>;
export declare const parseHttpRequestFromHeaders: <T>({ method, path, headers, httpVersionMajor, httpVersionMinor, isTransportSecure, body, }: {
    method: HttpMethod;
    path: string;
    headers: HttpHeaders;
    body: T;
    httpVersionMajor: number;
    httpVersionMinor: number;
    isTransportSecure: boolean;
}) => HttpServerRequest<T>;
export declare const writeHttpRequestHeaders: <T>({ content, expectContinue, headers, preconditions, preferences, }: HttpRequest<import("./interfaces").HttpContent<T>>, writeHeader: (header: string, value: string) => void) => void;
export declare const disallowProtocolAndHostForwarding: <T>() => Operator<HttpServerRequest<T>, HttpServerRequest<T>>;
export declare const httpRequestToUntypedHeaders: (request: HttpRequest<import("./interfaces").HttpContent<unknown>>) => {
    [key: string]: string;
};
//# sourceMappingURL=httpRequest.d.ts.map